import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        String key = Greenfoot.getKey();
        
        if ("up".equals(key))
        {
            moveTo(getX(), getY() - 1);
        }
        else if ("down".equals(key))
        {
            moveTo(getX(), getY() + 1);
        }
        else if ("left".equals(key))
        {
            moveTo(getX() - 1, getY());
        }
        else if ("right".equals(key))
        {
            moveTo(getX() + 1, getY());
        }
        
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null)
        {
            if (mouse.getClickCount() == 1)
            {
                throwAt(mouse.getX(), mouse.getY());
                endTurn();
            }
        }
    }    
    
    private static double calculateDirection(double x, double y)
    {
        return Math.toDegrees(Math.atan2(y, x));
    }
       
    private static double calculateX(double dir)
    {
        return Math.cos(Math.toRadians(dir));
    }
    
    private static double calculateY(double dir)
    {
        return Math.sin(Math.toRadians(dir));
    }
    
    public void throwAt(int x, int y)
    {
        System.out.println("Thrown at: " + x + ", " + y);
        
        Path p = new Path();
        double idealAngle = calculateDirection(x - getX(), y - getY());
        double actualAngle = idealAngle + (Greenfoot.getRandomNumber(40) - 20);
        
        p.followLine(getX(), getY(), calculateX(actualAngle), calculateY(actualAngle));
        
        BoxWorld w = (BoxWorld)getWorld();

        w.drawExactPath(w.toMiddle(getX()), w.toMiddle(getY()), w.toExact(p.endX), w.toExact(p.endY), Color.RED);
    }
    
    
    private class Path extends LineFollower
    {
        public double endX;
        public double endY;
        
        protected boolean process(int x, int y, double exactX, double exactY)
        {
            World w = getWorld();
            System.out.println("Checking: " + x + ", " + y);
            List obj = w.getObjectsAt(x, y, Box.class);
                        
            if (!obj.isEmpty())
            {
                // Box:
                endX = exactX;
                endY = exactY;
                return false; 
            }
            
            obj = w.getObjectsAt(x, y, Opponent.class);
            
            if (!obj.isEmpty())
            {
                // Dodger:
                endX = exactX;
                endY = exactY;
                ((Opponent)obj.get(0)).hit();
                return false; 
            }
            
            return true;
        }
    }
    
    
    private void moveTo(int x, int y)
    {
        World w = getWorld();
        List obj = w.getObjectsAt(x, y, Box.class);
        obj.addAll(w.getObjectsAt(x, y, Opponent.class));
        if (obj.isEmpty())
        {
            setLocation(x, y);
            endTurn();
        }
    }
    
    private void endTurn()
    {
        ((BoxWorld)getWorld()).opponentActions();
    }
}
